/*(c) 2006 Christian B. Huebschle*/
#include <ctype.h>
#ifdef _WIN32 
#include <shlobj.h>
#else
#include <unistd.h>
#endif
int Pa1=0,Pa2=1,Pa3=2,planemap=1;
unsigned short Kovalenz_Radien[109]={55, 0, 123, 90, 85, 77, 74, 73, 72, 0,
	154, 136, 118, 111, 106, 102, 99, 0, 
	203, 174, 144, 132, 122, 118, 117, 117, 116, 115, 117, 125, 126, 122, 120, 116, 114, 0,
	218, 191, 162, 145, 134, 130, 127, 125, 125, 128, 134, 148, 144, 141, 140, 136, 133, 0,
	235, 198, 169, 165, 165, 164, 164, 162, 185, 161, 159, 159, 157, 157, 156, 170, 156, 144, 134, 130, 128, 126, 127, 130, 134, 149, 148, 147, 146, 146, 145,
	0, 0, 0, 188, 165, 161, 142, 130, 151, 182, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; 
unsigned short ElNeg[83]={220, 550, 97, 147, 201, 250, 307, 350, 440, 480, 101, 123, 147, 174, 206, 244, 283, 320, 91, 104, 120, 132, 145, 156, 160, 164, 170, 175, 175, 166, 182, 202, 220, 248, 274, 290, 89, 99, 111, 122, 123, 130, 136, 142, 145, 130, 142, 146, 149, 172, 182, 201, 221, 240, 86, 97, 108, 108, 107,
 107, 107, 107, 110, 111, 110, 110, 110, 111, 111, 106, 114, 123, 133, 140, 146, 152, 155, 142, 142, 144, 144, 155, 167 };
class molekul {
 public:
  int atmax,NVs;
  char bondname[5000][20];
  double cx_1[3],cx_2[3],cx_3[3];
  char INIPATH[PATHLENGTH];     
  char ALT_INIPATH[PATHLENGTH] ;


  molekul(void) {//ein Konstruktor
    if (first_init){
      char  line[PATHLENGTH];
      char  test[PATHLENGTH]="NICE";
      strcpy(INIPATH,"moliso.ini");
      strcpy(ALT_INIPATH,"moliso.ini");
      FILE *ini;
      lod=8;
  if (getenv("HOME")) sprintf(ALT_INIPATH,"%s/.moliso/moliso.ini",getenv("HOME"));  
  if((ini=fopen(INIPATH,"r"))==NULL) {if((ini=fopen(ALT_INIPATH,"r"))==NULL) {
#ifdef _WIN32
      ini=OpenDatei(ALT_INIPATH,"r");
      strcpy(INIPATH,GLOBSTR);
#else
      ini=OpenDatei("*.ini","r","Open moliso.ini file");
      strcpy(INIPATH,GLOBSTR);
      
      strcpy(DIRSTR,GLOBSTR);
      char* pp = rindex(DIRSTR,'/');
      if (pp) DIRSTR[(pp-DIRSTR)]='\0';
    //  printf("-->%s<--\n",DIRSTR);
      chdir(DIRSTR);
#endif
  }else {printf("altini:%s\n",ALT_INIPATH);}}
  if (ini==NULL) exit(9);
  rewind(ini);  
  while ((1!=sscanf(line,"Iso_Grid=%[^\n]",iso_grd))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);    
  }
  rewind(ini);  
  while ((4!=sscanf(line,"CutPlaneAtoms %d %d %d %d\n",&Pa1,&Pa2,&Pa3, &planemap))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);    
  }

  rewind(ini);  
  while ((1!=sscanf(line,"Legend_Unit_Label=%[^\n]",lul))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);    
  }
  rewind(ini);  
  while ((1!=sscanf(line,"Legend_Unit_Conversion_Factor=%lf",&lucf))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);    
  }
  rewind(ini);  
  while ((1!=sscanf(line,"Use_Stored_Surface=%[^\n]",surf1))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);    
  }
  FILE *tst;
  if ((strcmp(surf1,""))&&(NULL!=(tst=fopen(surf1,"r")))) {
    fclose(tst); 
  }else {
    strcpy(surf1,"");
  }
  rewind(ini);  
  while ((1!=sscanf(line,"Store_Surface=%[^\n]",surf2))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);    
  }
  rewind(ini);  
  while ((1!=sscanf(line,"Mouse_Interaction=%d",&MOUSE_INTERACTION))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);    
  }
  /*rewind(ini);  
  while ((1!=sscanf(line,"Grad_Atom=%[^\n]",interestingSphere))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);    
  };*/
  rewind(ini);
  while ((1!=sscanf(line,"Map_Grid=%[^\n]",map_grd))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  rewind(ini);
  while ((1!=sscanf(line,"Refl_Texture=%[^\n]",refl_tex))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  rewind(ini);
  while ((0==(NVs=sscanf(line,"Iso_Value=%f%f",&iso_value,&iso_value2)))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  /*rewind(ini);
  while ((1!=sscanf(line,"Gradient_Cutoff=%f",&grad_cutoff))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }*/
  rewind(ini);
  while ((1!=sscanf(line,"XD_RES_PATH=%[^\n]",XD_RES_PATH))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  rewind(ini);
  while ((1!=sscanf(line,"Transparency_Mode=%[^\n]",test))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  NiTr=!(strcmp(test,"NICE"));
  rewind(ini);
  while ((1!=sscanf(line,"Enable_Ellipsoids=%[^\n]",test))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  Elli=(strcmp(test,"NO"));
  rewind(ini);
  while ((1!=sscanf(line,"Ellipsoide_Probability=%d",&proba))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  rewind(ini);
  while ((1!=sscanf(line,"Regular_Iterations=%d",&regula))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  rewind(ini);


  while ((1!=sscanf(line,"Movi_ffmpeg_Codec=%[^\n]",MoviCodec))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  rewind(ini);

  while ((1!=sscanf(line,"MoviStepSize[degree]=%lf",&MoviDegreeStepSize))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  rewind(ini);

  while ((1!=sscanf(line,"Sphere_Detail=%d",&lod))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  rewind(ini);
  while ((4!=sscanf(line,"Background_Color=%f %f %f %f",&WIN_COL[0],&WIN_COL[1],&WIN_COL[2],&WIN_COL[3]))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  while ((4!=sscanf(line,"Text_Color=%f %f %f %f",&TEXT_COL[0],&TEXT_COL[1],&TEXT_COL[2],&TEXT_COL[3]))&&(!feof(ini))) {
    fscanf(ini,"%[^\n]\n",line);
  }
  if (NVs<2) iso_value2=iso_value;
  fclose(ini);  
  //printf("--->>>%d %d %d\n",Pa1,Pa2,Pa3);
  if (lod<0) dratom=1;
  lod=(lod<0)?-lod:lod;
  char         actualPath[512]="",installPath[512]="";
#ifdef _WIN32
  ITEMIDLIST   *pathID;
  SHGetSpecialFolderLocation(NULL,CSIDL_PERSONAL, &pathID);
  SHGetPathFromIDList(pathID, actualPath);
  SHGetSpecialFolderLocation(NULL,CSIDL_PROGRAM_FILES, &pathID);
  SHGetPathFromIDList(pathID, installPath);
  printf("Searching for Atomcolors.dat in Working Directory,\nin \"%s\"\nand finaly in \"%s\\Moliso\".\n",
	  actualPath,installPath);
strcat(installPath,"\\moliso\\Atomcolors.dat");
#else
  strcat(installPath,"/usr/local/moliso/Atomcolors.dat");

  printf("Searching for Atomcolors.dat in Working Directory,\nin \"%s/.moliso/\"\nand finaly in \"%s\".\n",
          getenv("HOME"),installPath);

#endif 
  FILE *ATCOL; char achr2[512],achr[256]="Atomcolors.dat";
  if (NULL==(ATCOL=fopen(achr,"r"))) {
	  if (getenv("HOME")) sprintf(achr2,"%s/.moliso/%s",getenv("HOME"),achr); else 
      sprintf(achr2,"%s/moliso/%s",actualPath,achr);
    if (NULL==(ATCOL=fopen(achr2,"r"))) {
	if (NULL==(ATCOL=fopen(installPath,"r"))) printf ("\"%s\"\nand \"%s\" not found. Now Moliso uses default values.\n",achr2,installPath); 
    else{    ////
      int i=0;
      double KVR;	
      while (!feof(ATCOL)) {
	KVR=0.0;
	fscanf(ATCOL	,"%[^\n]\n",line);
	if ((line[0]!='!')&&(5<sscanf(line,"%d %f %f %f %f %f %lf\n",&acn[i],&Acol[i][0] ,&Acol[i][1] ,&Acol[i][2] ,&Acol[i][3],&arad[i],&KVR))) {
	  printf ("ATOMTYPE: %d color: %f %f %f %f radius: %4.2f\n",acn[i],Acol[i][0] ,Acol[i][1] ,Acol[i][2] ,Acol[i][3],arad[i]);
         if (KVR>0.0) {
	   printf("Kovalenzradius of ATOMTYPE: %d changed from %4.2f ",acn[i], Kovalenz_Radien[acn[i]-1]/100.0);
	   Kovalenz_Radien[acn[i]-1]=int (KVR*100.0); 	  
	   printf("to %f\n",Kovalenz_Radien[acn[i]-1]/100.0); 
	 } 
	 i++; 
	}
	acnn=i;    
      }
    }
  }
  }else {
    int i=0,ff;//ff
    double KVR;
    while (!feof(ATCOL)) {
      KVR=0.0;
      fscanf(ATCOL,"%[^\n]\n",line);
      if ((line[0]!='!')&&(5<(ff=sscanf(line,"%d %f %f %f %f %f %lf\n",&acn[i],&Acol[i][0] ,&Acol[i][1] ,&Acol[i][2] ,&Acol[i][3],&arad[i],&KVR)))) {
	printf ("ATOMTYPE: %d color: %f %f %f %f radius: %f\n",acn[i],Acol[i][0] ,Acol[i][1] ,Acol[i][2] ,Acol[i][3],arad[i]);
        if (KVR>0.00) {
	  printf("Kovalenzradius of ATOMTYPE: %d changed from %4.2f ",acn[i], Kovalenz_Radien[acn[i]-1]/100.0);
	  Kovalenz_Radien[acn[i]-1]=int (KVR*100.0);
	  printf("to %4.2f\n",Kovalenz_Radien[acn[i]-1]/100.0);
           }

	i++; 
      }
      acnn=i;    
    }
  }
  printf("Path to iso-grid: \"%s\"\n",iso_grd);
  printf("Path to map-grid: \"%s\"\n",map_grd);
  if (refl_tex[0]!='\0') printf("Path to sphere-map texture: \"%s\"\n",refl_tex);
  if (NVs==2) printf("Iso-values: \"%f  %f\"\n",iso_value,iso_value2);
  else printf("Iso-value: \"%f\"\n",iso_value);
  if (Elli) printf("Path to xd.res: \"%s\"\n",XD_RES_PATH);
  fflush(stdout);
  first_init=0;
  }   
  }//konstruktor
  ~molekul(){//destructor
  FILE *ini;
  if ((ini=fopen(INIPATH,"w"))!=NULL){
  printf("Saving %s ...\n",INIPATH);
  fprintf(ini,"Iso_Grid=%s\n",iso_grd);
  fprintf(ini,"Map_Grid=%s\n",map_grd);
  //fprintf(ini,"Grad_Atom=%s\n",interestingSphere);
  fprintf(ini,"Refl_Texture=%s\n",refl_tex);
  if (iso_value!=iso_value2) fprintf(ini,"Iso_Value=%f %f\n",iso_value, iso_value2);
  else fprintf(ini,"Iso_Value=%f \n",iso_value);
  //fprintf(ini,"Gradient_Cutoff=%f\n",grad_cutoff);
  fprintf(ini,"CutPlaneAtoms %d %d %d %d\n",Pa1,Pa2,Pa3,planemap);
  fprintf(ini,"Sphere_Detail=%d\n",lod);
  fprintf(ini,"XD_RES_PATH=%s\n",XD_RES_PATH);
  fprintf(ini,"Use_Stored_Surface=%s\n",surf1);
  fprintf(ini,"Store_Surface=%s\n",surf2);
  fprintf(ini,"Transparency_Mode=%s\n",(NiTr)?"NICE":"FAST");
  fprintf(ini,"Enable_Ellipsoids=%s\n",(Elli)?"YES":"NO");
  fprintf(ini,"Ellipsoid_Probability=%d\n",proba);  
  fprintf(ini,"Regular_Iterations=%d\n",regula);
  fprintf(ini,"Background_Color=%f %f %f %f\n",WIN_COL[0],WIN_COL[1],WIN_COL[2],WIN_COL[3]);
  fprintf(ini,"Text_Color=%f %f %f %f\n",TEXT_COL[0],TEXT_COL[1],TEXT_COL[2],TEXT_COL[3]);
  fprintf(ini,"Mouse_Interaction=%d\n",MOUSE_INTERACTION);
  fprintf(ini,"Legend_Unit_Conversion_Factor=%f\n",lucf);
  fprintf(ini,"Legend_Unit_Label=%s\n",lul);
  fprintf(ini,"MoviStepSize[degree]=%f\n",MoviDegreeStepSize);
  fprintf(ini,"Movi_ffmpeg_Codec=%s\n",MoviCodec);
  fclose(ini);}
      };//destructor
  void atoms(char **Atom,const GLfloat *koordinaten,char **Anr,const double dim,const double *UT,const int proba);
  void atoms(char **Atom,const GLfloat *koordinaten,char **Anr,const double dim);
  int bonds(char **Atom,const GLfloat *koordinaten,char **Anr,const double dim);
  int bondsl(char **Atom,const GLfloat *koordinaten,char **Anr,const double dim);
  double getrad(int j);
  void labels(char **Atom,const GLfloat *koordinaten,char **Anr, int view);
  int Get_OZ(char * S1);
  
 private:
  int lod;
  GLfloat Acol[18][4],arad[18];
  int acn[18],acnn;
  float* kreuzX(float x1,float y1,float z1,float x2,float y2,float z2);
  double* norm(double*);
  double*kreuzX(double x1,double y1,double z1,double x2,double y2,double z2);
  float winkel(float x1,float y1,float z1,float x2,float y2,float z2);
  double lang(double x,double y,double z);
  double * jacobi(double a[3][3], double d[3]); 
  void drawbon(int type,double rad,int ai,int aj,char **Atom,const GLfloat *koordinaten,char **Anr);
};
int molekul::Get_OZ( char * S1) {//109 Elemente sollten reichen zumindest fuer XD ;-)
  if (S1[0]=='X') S1+=3;
  S1[1]=tolower(S1[1]);
  char PSE_Symbol[109][3] = {"H","He","Li","Be","B","C","N","O","F","Ne","Na","Mg","Al","Si","P","S","Cl","Ar",
			     "K","Ca","Sc","Ti","V","Cr","Mn","Fe","Co","Ni","Cu","Zn","Ga","Ge","As","Se","Br","Kr",
			     "Rb","Sr","Y","Zr","Nb","Mo","Tc","Ru","Rh","Pd","Ag","Cd","In","Sn","Sb","Te","J","Xe",
			     "Cs","Ba", "La","Ce","Pr","Nd","Pm","Sm","Eu","Gd","Tb","Dy","Ho","Er","Tm","Yb","Lu",
			     "Hf","Ta","W","Re","Os","Ir","Pt","Au","Hg","Tl","Pb","Bi","Po","At","Rn","Fr","Ra",
			     "Ac","Th","Pa","U","Np","Pu","Am","Cm","Bk","Cf","Es","Fm","Md","No","Lr","Ku","Ha","Rf","Ns","Hs","Mt"};

  for (int i=0;i<109;i++) if (!strcmp(PSE_Symbol[i],S1)) return i;//Je hoeher die Ordnungzahl desto laenger dauerts Halt!! Dumm aber einfach.
  return -1;
}
#define ROTATE(a,i,j,k,l) g=a[i][j];h=a[k][l];a[i][j]=g-s*(h+g*tau); a[k][l]=h+s*(g-h*tau);
//Numerical Recepies....
double * molekul::jacobi(double a[3][3], double d[3]) { 
  int j,iq,ip,i,n=3,nrot; 
  double tresh,theta,tau,t,sm,s,h,g,c; 
  double b[3],z[3],v[3][3];
  static double erg[4]={0.0,1.0,0.0,0.0};
  v[0][0]=cx_1[0];
  v[0][1]=cx_2[0];
  v[0][2]=cx_3[0];
  v[1][0]=cx_1[1];
  v[1][1]=cx_2[1];
  v[1][2]=cx_3[1];
  v[2][0]=cx_1[2];
  v[2][1]=cx_2[2];
  v[2][2]=cx_3[2];

  for (ip=1;ip<=n;ip++) {  
    b[ip-1]=d[ip-1]=a[ip-1][ip-1]; 
    z[ip-1]=0.0; 
  } 
  nrot=0; 
  for (i=1;i<=150;i++) {
    sm=0.0; 
    for (ip=1;ip<=n-1;ip++) { 
      for (iq=ip+1;iq<=n;iq++) 
	sm += fabs(a[ip-1][iq-1]);       
    } 
    if (float(sm) == 0.0) { 
      if ((v[0][0]+v[1][1]+v[2][2])!=3.0) {        
      erg[0]=acos((v[0][0]+v[1][1]+v[2][2]-1.0)/2.0);
      erg[1]=(v[2][1]-v[1][2])/(2.0*sin(erg[0]));
      erg[2]=(v[0][2]-v[2][0])/(2.0*sin(erg[0]));
      erg[3]=(v[1][0]-v[0][1])/(2.0*sin(erg[0]));
      erg[0]*=180.0/M_PI;}
      else {erg[0]=0.0;erg[1]=1.0;erg[2]=0.0;erg[3]=0.0; }
      return (double*) erg; 
    }
    if (i < 4) tresh=0.001;  
    else tresh=0.00001;  
    for (ip=1;ip<=n-1;ip++) { 
      for (iq=ip+1;iq<=n;iq++) { 
	g=100.0*fabs(a[ip-1][iq-1]);  
	if ((i > 4) && ((fabs(d[ip-1])+g) == fabs(d[ip-1])) && ((fabs(d[iq-1])+g) == fabs(d[iq-1]))) {a[ip-1][iq-1]=0.0;}
	else if (fabs(a[ip-1][iq-1]) >= tresh) { 
	  h=d[iq-1]-d[ip-1]; 
	  if ((fabs(h)+g) == fabs(h)) {t=(a[ip-1][iq-1])/h; } 
	  else { theta=0.5*h/(a[ip-1][iq-1]);  
	  t=1.0/(fabs(theta)+sqrt(1.0+theta*theta)); 
	  if (theta < 0.0) {t = -1.0*t;}
	  } 
	  c=1.0/sqrt(1+t*t); 
	  s=t*c; 
	  tau=s/(1.0+c); 
	  h=t*a[ip-1][iq-1];
	  z[ip-1] -= h;
	  z[iq-1] += h;
	  d[ip-1] -= h;
	  d[iq-1] += h;
	  a[ip-1][iq-1]=0.0;
	  for (j=1;j<=ip-1;j++) { 
	    ROTATE(a,j-1,ip-1,j-1,iq-1)
	      } 
	  for (j=ip+1;j<=iq-1;j++) { 
	    ROTATE(a,ip-1,j-1,j-1,iq-1)	   
	      } 
	  for (j=iq+1;j<=n;j++) {  
	    ROTATE(a,ip-1,j-1,iq-1,j-1)
	      } 
	  for (j=1;j<=n;j++) { 
	    ROTATE(v,j-1,ip-1,j-1,iq-1) 
	      } 
	  ++(nrot);	  
	} 
      } 
    } 
    for (ip=1;ip<=n;ip++) { 
      b[ip-1] += z[ip-1];
      d[ip-1] =b[ip-1];
      z[ip-1] =0.0;
    } 
  } 
  erg[0]=acos((v[0][0]+v[1][1]+v[2][2]-1.0)/2.0);
  erg[1]=(v[2][1]-v[1][2])/(2.0*sin(erg[0]));
  erg[2]=(v[0][2]-v[2][0])/(2.0*sin(erg[0]));
  erg[3]=(v[1][0]-v[0][1])/(2.0*sin(erg[0]));
  erg[0]*=180.0/M_PI;  
  return (double*)erg;
}
GLfloat* molekul::kreuzX(GLfloat x1,GLfloat y1,GLfloat z1,GLfloat x2,GLfloat y2,GLfloat z2) {
  static float erg[3];
  erg[0]=-y1*z2+z1*y2;
  erg[1]=x1*z2-z1*x2;
  erg[2]=-x1*y2+y1*x2;
  return(erg);
}
double* molekul::norm(double *v){
	static double erg[3];
	double sm=sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
    erg[0]=v[0]/sm;
    erg[1]=v[1]/sm;
    erg[2]=v[2]/sm;
	return (erg);
}
double* molekul::kreuzX(double x1,double y1,double z1,double x2,double y2,double z2) {
  static double erg[3];
  erg[0]=-y1*z2+z1*y2;
  erg[1]=x1*z2-z1*x2;
  erg[2]=-x1*y2+y1*x2;
 // printf("===%f %f %f===\n",erg[0],erg[1],erg[2]);
  return(erg);
}
GLfloat molekul::winkel(GLfloat x1,GLfloat y1,GLfloat z1,GLfloat x2,GLfloat y2,GLfloat z2) {
  static GLfloat erg;
  erg=(x1*x2+y1*y2+z1*z2)/(sqrt(x1*x1+y1*y1+z1*z1)*sqrt(x2*x2+y2*y2+z2*z2));
  erg=acos(erg)/M_PI*180.0f;
  return(erg);
}
double molekul::lang(double x,double y,double z){
return sqrt(x*x+y*y+z*z);
}
void molekul::atoms( char **Atom,const GLfloat *koordinaten,char **Anr,const double dim,const double *UT,const int proba){//ADP Schwingungsellipsoide

  double rad,UTT[3][3],EV[3], *erg;
  //  GLdouble *matrix;
  //printf("\n");  
  for (int j=0;j<atmax;j++)
    {
      glLoadName(j);
      UTT[0][0]=UT[6*j];
      UTT[1][1]=UT[6*j+1];
      UTT[2][2]=UT[6*j+2];
      UTT[1][0]=UTT[0][1]=UT[6*j+3];
      UTT[2][0]=UTT[0][2]=UT[6*j+4];
      UTT[2][1]=UTT[1][2]=UT[6*j+5];      	
      glPushMatrix () ;         
      glTranslatef ( (koordinaten[j*3]),(koordinaten[j*3+1]),(koordinaten[j*3+2]) ) ;
      erg=jacobi(UTT,EV);
      glRotated(Ato4d(erg));//Orientierung der Ellipsoide
     
      //printf("%s(%d)-> %f %f %f %f\n",Atom[j],Anr[j],Ato4d(erg));
      switch (proba ) {
      case 10 :{ glScaled(0.76*sqrt(EV[0]),0.76*sqrt(EV[1]),0.76*sqrt(EV[2]));break;}   //Hauptachsen der Eliipsoide 10% Wahrscheinlichkeit
      case 30 :{ glScaled(1.19*sqrt(EV[0]),1.19*sqrt(EV[1]),1.19*sqrt(EV[2]));break;}   //Hauptachsen der Eliipsoide 30% Wahrscheinlichkeit
      case 50 :{ glScaled(1.54*sqrt(EV[0]),1.54*sqrt(EV[1]),1.54*sqrt(EV[2]));break;}   //Hauptachsen der Eliipsoide 50% Wahrscheinlichkeit
      case 70 :{ glScaled(1.91*sqrt(EV[0]),1.91*sqrt(EV[1]),1.91*sqrt(EV[2]));break;}   //Hauptachsen der Eliipsoide 70% Wahrscheinlichkeit
      case 90 :{ glScaled(2.50*sqrt(EV[0]),2.50*sqrt(EV[1]),2.50*sqrt(EV[2]));break;}   //Hauptachsen der Eliipsoide 90% Wahrscheinlichkeit
      }
      //printf("%s(%d) %f %f %f U1: %f U2: %f U3: %f\n ",Atom[j],Anr[j], koordinaten[j*3],koordinaten[j*3+1],koordinaten[j*3+2],EV[0], EV[1], EV[2]); fflush(stdout);

      rad=1.0/dim;
      switch(Get_OZ(Atom[j])){// fuer jede Atomsorte Radius und
      case 0:glColor4f(0.7f,0.7f,0.7f,1.0f);break;
      case 5:glColor4f(0.2f,0.2f,0.3f,1.0f);break;
      case 6:glColor4f(0.0f,0.6f,0.2f,1.0f);break;
      case 7:glColor4f(0.6f,0.0f,0.2f,1.0f);break;
      case 15:glColor4f(0.7f,0.7f,0.2f,1.0f);break;
      case 8:glColor4f(0.3f,0.6f,0.3f,1.0f);break;
      case 16:glColor4f(0.3f,0.5f,0.3f,1.0f);break;	
	//default: glColor4f(0.5f,0.0f,0.5f,1.0f);break;
      default: glColor4fv(Acol[1]);break;

      }         
      for (int i=0; i<acnn;i++) if (Get_OZ(Atom[j])==(acn[i]-1)) {glColor4fv(Acol[i]); }
      if (!dratom) glutSolidSphere(rad,6*lod,6*lod);//Atom als Kugel zeichnen
      else glutWireSphere(rad,6*lod,6*lod);//Atom als Kugel zeichnen
      //glutSolidCube(rad);
      glPopMatrix(); 
    }
}
void molekul::atoms( char **Atom,const GLfloat *koordinaten,char **Anr,const double dim) {
  double rad;
  printf("CutPlane defined by %s%s %s%s %s%s \n",Atom[Pa1],Anr[Pa1],Atom[Pa2],Anr[Pa2],Atom[Pa3],Anr[Pa3]);

  printf("CutPlane is mapped with %s_Grid-Values \n",(planemap)?"Iso":"Map");
  double lll,*hkl=(double*)malloc(sizeof(double)*3);
  hkl=(double*)kreuzX( (double)koordinaten[Pa2*3]-koordinaten[Pa1*3],
		       ((double)koordinaten[Pa2*3+1]-koordinaten[Pa1*3+1]),
		       ((double)koordinaten[Pa2*3+2]-koordinaten[Pa1*3+2]),	      
		       (double)koordinaten[Pa3*3]-koordinaten[Pa1*3],
		       ((double)koordinaten[Pa3*3+1]-koordinaten[Pa1*3+1]),
		       ((double)koordinaten[Pa3*3+2]-koordinaten[Pa1*3+2]));
  hplan=hkl[0];
  kplan=hkl[1]/yrat;
  lplan=hkl[2]/zrat;
  lll=sqrt(hplan*hplan+kplan*kplan+lplan*lplan);
  hplan/=lll;
  kplan/=lll;
  lplan/=lll;
  Pdist=( (koordinaten[Pa1*3  ]-0.5)*hplan+
	  (koordinaten[Pa1*3+1]-0.5)*kplan*yrat+
	  (koordinaten[Pa1*3+2]-0.5)*lplan*zrat);
  //printf("h%f k%f l%f dist%f  \n",hplan,kplan,lplan,Pdist);
  for (int j=0;j<atmax;j++){  
    glLoadName(j);
    //printf("%d %d\n",j,atmax);fflush(stdout);
    glPushMatrix ();    
	glBindTexture(GL_TEXTURE_2D, texture[0]);
    glTranslatef ( (koordinaten[j*3]/1.0),(koordinaten[j*3+1]/1.0),(koordinaten[j*3+2]/1.0) ) ;
    //    printf("%s hat OZ %d\n",Atom[j],Get_OZ(Atom[j]));
    switch(Get_OZ(Atom[j])){// fuer jede Atomsorte Radius und
    case 0:rad=0.1/dim;glColor4f(0.7f,0.7f,0.6f,1.0f);break;
    case 5:rad=0.25/dim;glColor4f(0.2f,0.2f,0.3f,1.0f);break;
    case 6:rad=0.24/dim;glColor4f(0.0f,0.6f,0.2f,1.0f);break;
    case 7:rad=0.23/dim;glColor4f(0.6f,0.0f,0.2f,1.0f);break;
    case 15:rad=0.34/dim;glColor4f(0.7f,0.7f,0.2f,1.0f);break;
    case 8:rad=0.21/dim;glColor4f(0.3f,0.6f,0.3f,1.0f);break;
    case 16:rad=0.34/dim;glColor4f(0.3f,0.5f,0.3f,1.0f);break;
    default: rad=0.3/dim;glColor4f(0.5f,0.0f,0.5f,1.0f);break;
 }
         
  for (int i=0; i<acnn;i++) if (Get_OZ(Atom[j])==(acn[i]-1)) {glColor4fv(Acol[i]); rad=(arad[i])?arad[i]/dim:Kovalenz_Radien[Get_OZ(Atom[j])]/(57*dim);}
      if (!dratom) glutSolidSphere(rad,6*lod,6*lod);//Atom als Kugel zeichnen
      else glutWireSphere(rad,6*lod,6*lod);//Atom als Kugel zeichnen
    //glutSolidCube(rad*3);
    glPopMatrix(); 
  }
}  

////////////////////////////////////////////////////////////////////////////////////////
void molekul::drawbon(int type,double rad,int ai,int aj,char **Atom,const GLfloat *koordinaten,char **Anr){
  double gg,soll_abst,ggn,before;
  float * vec,wink;
  double *vec2;
  int bc_istda=0;
  for (int m=0; m<acnn;m++) 
    if (acn[m]==0) {
    bc_istda=1;// bond-color ist da
    glColor4fv(Acol[m]);
    rad=arad[m]/dim;
    type=4;
//    printf("bond-color ist da %f %f\n",rad, arad[m]);
    }
  if (!bc_istda){
  switch(Get_OZ(Atom[ai])){// fuer jede Atomsorte Radius und    
  case 0:glColor4f(0.7f,0.7f,0.6f,1.0f);break;    
  case 5:glColor4f(0.2f,0.2f,0.3f,1.0f);break;    
  case 6:glColor4f(0.0f,0.6f,0.2f,1.0f);break;    
  case 7:glColor4f(0.6f,0.0f,0.2f,1.0f);break;    
  case 15:glColor4f(0.7f,0.7f,0.2f,1.0f);break;    
  case 8:glColor4f(0.3f,0.6f,0.3f,1.0f);break;    
  case 16:glColor4f(0.3f,0.5f,0.3f,1.0f);break;    
  default: glColor4f(0.5f,0.0f,0.5f,1.0f);break; 
  }
  for (int m=0; m<acnn;m++) if (Get_OZ(Atom[ai])==(acn[m]-1)) {glColor4fv(Acol[m]); }
  //printf("NEIN! bond-color ist da\n");
  }
  vec=kreuzX((float)koordinaten[ai*3]-koordinaten[aj*3],(float)koordinaten[ai*3+1]-koordinaten[aj*3+1],(float)koordinaten[ai*3+2]-koordinaten[aj*3+2],
	     0.0f,0.0f,1.0f);                 //Achse senkrecht zur Ebene Ursprung, Bindungs-Ende, Z-Achse 
  
  if (type==3) {
    before=1000;
    for (int n=0;n<atmax;n++){
      soll_abst=(Kovalenz_Radien[Get_OZ(Atom[ai])]+
		 Kovalenz_Radien[Get_OZ(Atom[n])])*2.1;
      ggn=dim*100.0*sqrt( pow((double)koordinaten[ai*3]   -koordinaten[n*3]  ,2.0)//Bindungslaenge berechnen
			  +pow((double)koordinaten[ai*3+1]-koordinaten[n*3+1],2.0)
			  +pow((double)koordinaten[ai*3+2]-koordinaten[n*3+2],2.0));
      if ((ggn<soll_abst)&&(n!=aj)&&(n!=ai)&&(ggn<before)) {//krzeste Nachbarbindung fr Ebene
	before=ggn;
	vec2=//erst vektor senkrecht zur Ebene
	  kreuzX((double)koordinaten[ai*3]-koordinaten[aj*3],(double)koordinaten[ai*3+1]-koordinaten[aj*3+1],(double)koordinaten[ai*3+2]-koordinaten[aj*3+2],
		 (double)koordinaten[ai*3]-koordinaten[n*3],(double)koordinaten[ai*3+1]-koordinaten[n*3+1],(double)koordinaten[ai*3+2]-koordinaten[n*3+2]);
	vec2=//dann vekor senrecht zur bindung und ebenennormalen
	  kreuzX((double)koordinaten[ai*3]-koordinaten[aj*3],(double)koordinaten[ai*3+1]-koordinaten[aj*3+1],(double)koordinaten[ai*3+2]-koordinaten[aj*3+2],
		 (double)vec2[0],(double)vec2[1],(double)vec2[2]);
	vec2=norm(vec2);//normieren
      }
    }	
    glPushMatrix();	
    glTranslatef ((float)koordinaten[ai*3]-1.5*rad*vec2[0],(float)koordinaten[ai*3+1]-1.5*rad*vec2[1],(float)koordinaten[ai*3+2]-1.5*rad*vec2[2]);//Anfangspunkt 	
    wink=180+winkel(koordinaten[ai*3]-koordinaten[aj*3],koordinaten[ai*3+1]-koordinaten[aj*3+1],koordinaten[ai*3+2]-koordinaten[aj*3+2],
		    0.0,0.0,1.0);               // Winkel zwischen Bindungs-Richtung und Z-Achse
    glRotatef(wink,vec[0],vec[1],vec[2]); // drehen
    GLUquadricObj *q = gluNewQuadric();
    gluQuadricNormals(q, GL_SMOOTH);   // ein Zylinder
    gluQuadricTexture(q,GL_TRUE);
    if (type==2) glEnable(GL_TEXTURE_2D);
    gg=dim*100.0*sqrt( pow((double)koordinaten[ai*3]   -koordinaten[aj*3]  ,2.0)//Bindungslaenge berechnen
		       +pow((double)koordinaten[ai*3+1]-koordinaten[aj*3+1],2.0)
		       +pow((double)koordinaten[ai*3+2]-koordinaten[aj*3+2],2.0));
    gluCylinder(q, rad, rad, (float)gg/(200.0f*dim), 8, 5); 
    glPopMatrix();
  }else {vec2=(double*)malloc(sizeof(double)*3);vec2[0]=0;vec2[1]=0;vec2[2]=0;}
  glPushMatrix();	
  glBindTexture(GL_TEXTURE_2D, texture[1]);//fr gestrichelte Bindungen type 2
  glEnable(GL_ALPHA_TEST);
  glTranslatef ((float)koordinaten[ai*3]+1.5*rad*vec2[0],(float)koordinaten[ai*3+1]+1.5*rad*vec2[1],(float)koordinaten[ai*3+2]+1.5*rad*vec2[2]);//Anfangspunkt 	
  wink=180+winkel(koordinaten[ai*3]-koordinaten[aj*3],koordinaten[ai*3+1]-koordinaten[aj*3+1],koordinaten[ai*3+2]-koordinaten[aj*3+2],
		  0.0,0.0,1.0);               // Winkel zwischen Bindungs-Richtung und Z-Achse
  glRotatef(wink,vec[0],vec[1],vec[2]); // drehen
  GLUquadricObj *q = gluNewQuadric();
  gluQuadricNormals(q, GL_SMOOTH);   // ein Zylinder
  gluQuadricTexture(q,GL_TRUE);
  if (type==2) glEnable(GL_TEXTURE_2D);
  gg=dim*100.0*sqrt( pow((double)koordinaten[ai*3]   -koordinaten[aj*3]  ,2.0)//Bindungslaenge berechnen
		     +pow((double)koordinaten[ai*3+1]-koordinaten[aj*3+1],2.0)
		     +pow((double)koordinaten[ai*3+2]-koordinaten[aj*3+2],2.0));
  gluCylinder(q, rad, rad, (float)gg/(200.0f*dim), 8, 5); 
  glDisable(GL_TEXTURE_2D);	
  glDisable(GL_ALPHA_TEST);	
  glPopMatrix();	//if type 
}
////////////////////////////////////////////////////////////////////////////////////////


int molekul::bonds( char **Atom,const GLfloat *koordinaten,char **Anr,const double dim) {
//printf("testbond\n");
  //BINDUNGEN ab hier
  GLfloat rad=0.05/dim;  
  glColor3f(0.4f,0.3f,0.2f);         
  for (int i=0; i<acnn;i++) if (0==(acn[i])) {glColor4fv(Acol[i]);rad=arad[i]/dim;}
//  double gg,soll_abst;
  int bnr=atmax,type=0;
  char dmy[500];
  FILE *bl=NULL;
  if (NULL!=(bl=fopen("bondlist.in","r"))) { 
    fscanf(bl,"%[^\n]\n",dmy);	  
    //printf("%s\n",dmy);	  
    int ai,aj;	  
    while (!feof(bl)){		  	    
      fscanf(bl,"%*s %*s %d %d %d\n",&ai,&aj,&type);		  	    
      if (type){ 		    	      
	bnr++;			  		    	      
	glLoadName(bnr);	
	sprintf(bondname[bnr-atmax], "%s%s---%s%s %d\n",Atom[ai],Anr[ai],Atom[aj],Anr[aj],type);
	drawbon(type,rad,ai,aj,Atom,koordinaten,Anr);

      }	//if type 
    }//while feof

  }//if bondlist.in
  else {
    double gg,soll_abst;
    bl=fopen("bondlist.out","w"); 
    if (bl) fprintf(bl,"bondname(ignored) Atom_nuber1  Atom_nuber2 type (Atom nubers start with 0) (type 1=bond 0=no bond 2=dashed bond 3=double bond)\n");
    for (int i=0;i<atmax;i++) {
      for (int j=0;j<atmax;j++) {
	if (i==j) continue;
	soll_abst=((Kovalenz_Radien[Get_OZ(Atom[i])]+
				Kovalenz_Radien[Get_OZ(Atom[j])])
			-(0.08*fabs((double)ElNeg[Get_OZ(Atom[i])]
        -ElNeg[Get_OZ(Atom[j])])))*1.1;
      gg=dim*100.0*sqrt( pow((double)koordinaten[i*3]   -koordinaten[j*3]  ,2.0)//Bindungslaenge berechnen
			+pow((double)koordinaten[i*3+1]-koordinaten[j*3+1],2.0)
			+pow((double)koordinaten[i*3+2]-koordinaten[j*3+2],2.0));
	  type=0;
      if (gg<soll_abst) {
		//  printf("%s%s--%s%s  %f %f %d %d\n",Atom[i],Anr[i],Atom[j],Anr[j],soll_abst,soll_abst-gg
		//  ,ElNeg[Get_OZ(Atom[i])],ElNeg[Get_OZ(Atom[i])]);		  		  
	type=1;		 
	if ((strcmp(Atom[i],"H"))&&(strcmp(Atom[j],"H")))		 
	  type=(soll_abst-gg>21.6)?3:1;			  
	bnr++;			  
	glLoadName(bnr);	
	sprintf(bondname[bnr-atmax],"%s%s---%s%s",Atom[i],Anr[i],Atom[j],Anr[j]);
	drawbon(type,rad,i,j,Atom,koordinaten,Anr);	
	}	//if type 
	  if (bl) fprintf(bl,"%2s%-6s%2s%-6s  %4d %4d    %1d\n",Atom[i],Anr[i],Atom[j],Anr[j],i,j,type);
    }//X
  }
  
  }
  if (bl) fclose(bl);
  //glutSetTexture( tex );
  //  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
  //  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
  return bnr;
}
int molekul::bondsl( char **Atom,const GLfloat *koordinaten,char **Anr,const double dim) {

//printf("testbondLine\n");
  int bnr=atmax;
  glDisable(GL_LIGHTING);
  glLineWidth(3);
  //BINDUNGEN ab hier
  glColor3f(0.4f,0.3f,0.2f);       
  for (int i=0; i<acnn;i++) if (0==(acn[i])) glColor4fv(Acol[i]);
  double gg,soll_abst;
  char dmy[256];
  FILE *bl=NULL;
  if (NULL!=(bl=fopen("bondlist.in","r"))) {
	  fscanf(bl,"%[^\n]\n",dmy);
	  int ai,aj,type;
	  while (!feof(bl)){
		  fscanf(bl,"%*s %*s %d %d %d\n",&ai,&aj,&type);
		  if (type){
			  bnr++;
			  glLoadName(bnr);
			  gg=dim*100.0*sqrt( pow((double)koordinaten[ai*3]   -koordinaten[aj*3]  ,2.0)//Bindungslaenge berechnen
			+pow((double)koordinaten[ai*3+1]-koordinaten[aj*3+1],2.0)
			+pow((double)koordinaten[ai*3+2]-koordinaten[aj*3+2],2.0));
	  
	  bnr++;
	glLoadName(bnr);
	//printf(		"%s%s---%s%s %d\n",Atom[ai],Anr[ai],Atom[aj],Anr[aj],type);
//	sprintf(bondname[bnr-atmax],"%s%s=%s%s",Atom[i],Anr[i],Atom[j],Anr[j]);
	glLineStipple(1,3855);	
	//glBindTexture(GL_TEXTURE_2D, texture[1]);
	if (type==2) glEnable(GL_LINE_STIPPLE);
	//if (type==2) glEnable(GL_TEXTURE_2D);
	glPushMatrix();
	glBegin(GL_LINES);
	glVertex3d(koordinaten[ai*3],koordinaten[ai*3+1],koordinaten[ai*3+2]);
	glVertex3d(koordinaten[aj*3],koordinaten[aj*3+1],koordinaten[aj*3+2]);
	glEnd();
	glDisable(GL_LINE_STIPPLE);
	//glDisable(GL_TEXTURE_2D);	
	glPopMatrix();}
	  }
  }
  else {
  for (int i=0;i<atmax;i++) {
    for (int j=i+1;j<atmax;j++) {
      soll_abst=(Kovalenz_Radien[Get_OZ(Atom[i])]+
		 Kovalenz_Radien[Get_OZ(Atom[j])])*1.1;
      
      gg=dim*100.0*sqrt(pow((double)koordinaten[i*3]   -koordinaten[j*3]  ,2.0)//Bindungslaenge berechnen
	      +pow((double)koordinaten[i*3+1]-koordinaten[j*3+1],2.0)
	      +pow((double)koordinaten[i*3+2]-koordinaten[j*3+2],2.0));
      if (gg<soll_abst) { // wenn kuerzer 
	bnr++;
	glLoadName(bnr);
//	sprintf(bondname[bnr-atmax],"%s%s=%s%s",Atom[i],Anr[i],Atom[j],Anr[j]);
	glPushMatrix();
	glBegin(GL_LINES);
	glVertex3d(koordinaten[i*3],koordinaten[i*3+1],koordinaten[i*3+2]);
	glVertex3d(koordinaten[j*3],koordinaten[j*3+1],koordinaten[j*3+2]);
	glEnd();
	glPopMatrix(); 
	  }
    }
  }
  }
  glLineWidth(1);
  glEnable(GL_LIGHTING);
  return bnr;
}    
double molekul::getrad(int j){
  double rad;
  for (int i=0; i<acnn;i++)     
    if (j==(acn[i]-1)) return rad=arad[i]/(dim-2.0)+0.002;
  return Kovalenz_Radien[j]/(100*dim*3)+0.002;
}
void molekul::labels( char **Atom,const GLfloat *koordinaten,char **Anr, int view) {
  //LABELS  
  //  printf("VIEW_%d\n",view);
  glDisable( GL_DEPTH_TEST ); 
  
  //float matrix[16];    
  char at[19],anr[17];
  double rad=0.012;
  switch (view) {
  case 0:
    glPushMatrix();{
      for (int j=0;j<atmax;j++){
	rad=getrad(Get_OZ(Atom[j]));
	glLoadName(j);
	glRasterPos3f(koordinaten[j*3]+rad,koordinaten[j*3+1],koordinaten[j*3+2]);    
	strcpy(at,Atom[j]);
	sprintf(anr,"%s",Anr[j]);
	strcat(at,anr);
	//      if (at[0]=='X') glColor3f(1.,1.,0.); else glColor3f(1.,1.,1.);	
	glPrint(at);
      }    
    }glPopMatrix();  
    break;
  case 1:
    glPushMatrix();{
      for (int j=0;j<atmax;j++){
	rad=getrad(Get_OZ(Atom[j]));
	glLoadName(j);
	glRasterPos3f(koordinaten[j*3],koordinaten[j*3+1]+rad,koordinaten[j*3+2]);    
	strcpy(at,Atom[j]);
	sprintf(anr,"%s",Anr[j]);
	strcat(at,anr);
	//      if (at[0]=='X') glColor3f(1.,1.,0.); else glColor3f(1.,1.,1.);	
	glPrint(at);
      }    
    }glPopMatrix();  
    break;
  case 2:
    glPushMatrix();{
      for (int j=0;j<atmax;j++){
	rad=getrad(Get_OZ(Atom[j]));
	glLoadName(j);
	glRasterPos3f(koordinaten[j*3],koordinaten[j*3+1],koordinaten[j*3+2]+rad);    
	strcpy(at,Atom[j]);
	sprintf(anr,"%s",Anr[j]);
	strcat(at,anr);
	//      if (at[0]=='X') glColor3f(1.,1.,0.); else glColor3f(1.,1.,1.);	
	glPrint(at);
      }    
    }glPopMatrix();  
    break;
  case 3:
    glPushMatrix();{
      for (int j=0;j<atmax;j++){
	rad=getrad(Get_OZ(Atom[j]));
	glLoadName(j);
	glRasterPos3f(koordinaten[j*3],koordinaten[j*3+1],koordinaten[j*3+2]-rad);    
	strcpy(at,Atom[j]);
	sprintf(anr,"%s",Anr[j]);
	strcat(at,anr);
	//      if (at[0]=='X') glColor3f(1.,1.,0.); else glColor3f(1.,1.,1.);	
	glPrint(at);
      }    
    }glPopMatrix();  
    break;
  case 4:
    glPushMatrix();{
      for (int j=0;j<atmax;j++){
	rad=getrad(Get_OZ(Atom[j]));
	glLoadName(j);
	glRasterPos3f(koordinaten[j*3],koordinaten[j*3+1]-rad,koordinaten[j*3+2]);    
	strcpy(at,Atom[j]);
	sprintf(anr,"%s",Anr[j]);
	strcat(at,anr);
	//      if (at[0]=='X') glColor3f(1.,1.,0.); else glColor3f(1.,1.,1.);	
	glPrint(at);
      }    
    }glPopMatrix();  
    break;
  case 5:
    glPushMatrix();{
      for (int j=0;j<atmax;j++){
	rad=getrad(Get_OZ(Atom[j]));
	glLoadName(j);
	glRasterPos3f(koordinaten[j*3]-rad,koordinaten[j*3+1],koordinaten[j*3+2]);    
	strcpy(at,Atom[j]);
	sprintf(anr,"%s",Anr[j]);
	strcat(at,anr);
	//      if (at[0]=='X') glColor3f(1.,1.,0.); else glColor3f(1.,1.,1.);		
	glPrint(at);
      }    
    }glPopMatrix();  
    break;
  }
  glEnable( GL_DEPTH_TEST ); 
}
